import gisConfig from '../config/gis';
import esriLoader from 'esri-loader';

console.log('test---geometry');

export function toGeometry(jsonObj, mapMng) {
  var geometry,
    mm = mapMng || mapManager;
  if (jsonObj) {
    jsonObj.spatialReference = {
      wkid: mm.view.spatialReference.wkid,
    };
    geometry = AllDependenciesLoadedModules['jsonUtils'].fromJSON(jsonObj);
  }
  return geometry;
}

const toGeometryDependenciesModules = {
  jsonUtils: 'gis/geometry/support/jsonUtils',
};
const getDefaultSymbolDependenciesModules = {
  SimpleMarkerSymbol: 'gis/symbols/SimpleMarkerSymbol',
  SimpleLineSymbol: 'gis/symbols/SimpleLineSymbol',
  SimpleFillSymbol: 'gis/symbols/SimpleFillSymbol',
  Color: 'gis/Color',
};
const ALLDependenciesModules = Object.assign(
  {},
  toGeometryDependenciesModules,
  getDefaultSymbolDependenciesModules,
);
const AllDependenciesLoadedModules = {};

export async function loadAllDependencies() {
  isRequestLoadModules(ALLDependenciesModules, AllDependenciesLoadedModules)
    ? await loadCommonModules(ALLDependenciesModules, AllDependenciesLoadedModules)
    : '';
}

export async function loadToGeometryDependencies() {
  isRequestLoadModules(toGeometryDependenciesModules, AllDependenciesLoadedModules)
    ? await loadCommonModules(toGeometryDependenciesModules, AllDependenciesLoadedModules)
    : '';
}

export async function loadGetDefaultSymbolDependencies() {
  isRequestLoadModules(getDefaultSymbolDependenciesModules, AllDependenciesLoadedModules)
    ? await loadCommonModules(getDefaultSymbolDependenciesModules, AllDependenciesLoadedModules)
    : '';
}

async function loadCommonModules(modulesUrlsObject, loadedModuleObject) {
  let moduleArr = Object.entries(modulesUrlsObject);
  let moduleUrlsArray = moduleArr.map((item) => item[1]);
  let modules = await esriLoader.loadModules(moduleUrlsArray, gisConfig);
  modules.map(
    function (module, index) {
      loadedModuleObject[moduleArr[index][0]] = module;
    }.bind(this),
  );
}

function isRequestLoadModules(originModules, targetModule) {
  let flag = false;
  for (let key in originModules) {
    if (!flag && !targetModule[key]) flag = true;
  }
  return flag;
}
